/**********************************************************************
 *
 * browsetools.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: browsetools.h 284 1999-06-24 05:12:25Z sjboddie $
 *
 *********************************************************************/


#ifndef BROWSETOOLS_H
#define BROWSETOOLS_H

#include "gsdlconf.h"
#include "text_t.h"
#include "cgiargs.h"
#include "display.h"
#include "recptproto.h"

void output_book_toc (const text_t &classifytitle, cgiargsclass &args, 
		      recptproto *collectproto, displayclass &disp, 
		      outconvertclass &outconvert, ostream &textout, 
		      ostream &logout);
void output_top_book_toc (ResultDocInfo_t docinfo, cgiargsclass &args, recptproto *collectproto, 
			  displayclass &disp, outconvertclass &outconvert, 
			  ostream &textout, ostream &logout);
void output_standard_book_toc (ResultDocInfo_t docinfo, cgiargsclass &args, recptproto *collectproto, 
			       displayclass &disp, outconvertclass &outconvert, 
			       ostream &textout, ostream &logout);
void output_hierarchy_toc (const text_t &classifytitle, cgiargsclass &args, 
			   recptproto *collectproto, displayclass &disp, 
			   outconvertclass &outconvert,ostream &textout, 
			   ostream &logout);
void output_datelist_toc (const text_t &classifytitle, cgiargsclass &args, 
			  recptproto *collectproto, displayclass &disp, 
			  outconvertclass &outconvert, ostream &textout, 
			  ostream &logout);
void output_list_toc (const text_t &classifytitle, cgiargsclass &args, 
		      recptproto *collectproto, displayclass &disp, 
		      outconvertclass &outconvert, ostream &textout, 
		      ostream &logout);
void output_azlist_toc (const text_t &classifytitle, cgiargsclass &args,
			recptproto *collectproto, displayclass &disp, 
			outconvertclass &outconvert, ostream &textout, 
			ostream &logout); 
void output_contracted_hierarchy_toc (cgiargsclass &args, recptproto *collectproto,
				      displayclass &disp, outconvertclass &outconvert,
				      ostream &textout, ostream &logout);
void output_expanded_hierarchy_toc (cgiargsclass &args, recptproto *collectproto,
				    displayclass &disp, outconvertclass &outconvert,
				    ostream &textout, ostream &logout);
void output_parents_toc (cgiargsclass &args, const text_tarray &parents,
			 int &tabcount, int &colnum, displayclass &disp,
			 recptproto *collectproto, outconvertclass &outconvert,
			 ostream &textout, ostream &logout);
void output_siblings_toc (cgiargsclass &args, const FilterResponse_t &siblings, 
			  int &tabcount, int &colnum, displayclass &disp, 
			  outconvertclass &outconvert, ostream &textout, ostream &logout);
void set_arrow_macros (const text_t &OID, const text_t &classifytype,
		       displayclass &disp, recptproto *collectproto, 
		       const text_t &collection, ostream &logout);
void output_controls (cgiargsclass &args, recptproto *collectproto, 
		      displayclass &disp, outconvertclass &outconvert, 
		      ostream &textout, ostream &logout);
void output_cover_image (cgiargsclass &args, recptproto *collectproto, 
			 displayclass &disp, outconvertclass &outconvert, 
			 ostream &textout, ostream &logout);




#endif
